(module bp-ddl
  mzscheme
  
  (require "list.ss"
           (prefix su. "sql-utils3.scm")
           (prefix lazy. "sql-utils-lazy3.scm")
           (prefix qa. "query-gen-adv.scm")
           (prefix meta. "meta.scm")
           (prefix al. "alists.scm")
           (prefix sp. "sql-procedures3.scm")
           "utils.scm")
  
  
  (provide tables
           procedures
           all-tables)
  
  (define tables (map car (al.val meta.raw_meta 'tables)))
  
  (define (all-tables proc)
    (map proc tables))
  
  (define procedures (append (all-tables su.table-proc-delete-ddl)
                               (all-tables su.table-proc-delete2-ddl)
                               (all-tables su.table-proc-pack-ddl)
                               (all-tables su.table-proc-unpack-ddl)
                               (all-tables su.table-proc-touch-ddl)
                               (all-tables su.table-proc-fill-childs-ddl)
                               (all-tables lazy.proc-get-lazy-ddl3)
                               (all-tables qa.shallow-copy-record-proc-ddl)
                               (sp.procedures)
                               (list (su.touch-object-proc-ddl)
                                     (su.delete-object-proc-ddl)
                                     (su.unpack-object-proc-ddl)
                                     (su.lazy-copy-restore-proc-ddl)
                                     (su.encode64-proc-ddl)
                                     (lazy.proc-all-get-lazy-ddl3))))
  
  )
