(define-syntax define-doc
  (lambda (stx)
    (syntax-case stx ()
      [(_ doc-name content)
       (let* ([_symn (syntax-e (syntax doc-name))]
              [_name (symbol->string _symn)]
              [_mix (lambda args
                   (datum->syntax-object
                    (syntax doc-name)
                    (string->symbol (apply string-append args))))])
         (with-syntax ([_z (_mix _name)]
                       [_cnt (datum->syntax-object
                             (syntax k)
                             `(let ([$doc ',_symn])
                                ,(syntax-object->datum (syntax content))))])
           (syntax
            (define _z _cnt))))])))
