(require (prefix su. "sql-utils3.scm")
         (prefix du. "ddl-utils.scm")
         (prefix bp. "bp-ddl.scm")
         (prefix meta. "meta.scm");// do not delete, used in a.bat
         (prefix di. "ddl-index.scm")
         "utils.scm")

(define (disp-proc-ddl)
  (newline)
  (map du.display-pre bp.procedures)
  (map du.display-post bp.procedures)
  (newline))

(define (disp-table-init)
  (let* ([ddl (map (lambda (table) (format "INSERT INTO \"t~a\"(\"fObject\") VALUES ('000000000000');\n" table)) bp.tables)])
    
    (map display ddl)
    (display "COMMIT;\n")))

(define (disp-table-ddl)
  (display (su.create-table-ddl))
  (disp-table-init)
  (display (apply mix (map su.table-add-pk-ddl bp.tables)))
  (display "COMMIT;")
  (newline)
  (display (apply mix (apply append (map su.table-add-fk-ddl bp.tables))))
  (display "COMMIT;")
  (newline)
  (display (di.create-index-ddl))
  (display "COMMIT;")
  (newline)
  (newline))

(define (disp-deactivate)
  (map display (map du.proc-dis-ddl bp.procedures))
  (display "COMMIT;")
  (newline)
  (map display (map du.proc-del-ddl bp.procedures))
  (display "COMMIT;")
  (newline)
  (map display (apply append (map su.table-del-fk-ddl bp.tables)))
  (display "COMMIT;")
  (newline)
  (map display (map su.table-del-pk-ddl bp.tables))
  (display "COMMIT;")
  (newline)
  (display (di.drop-index-ddl))
  (display "COMMIT;")
  (newline)
  (newline))

;*(disp-table-ddl)
;*(disp-proc-ddl)
;*(disp-deactivate)
;*(disp-table-init)
