function NDSByWords(q: TfrxUIBQuery; c: string): string;
var
  i: Integer;
  h: Integer;                           
  n: array of Variant;
  k: Double;                         
  v: Double;                         
begin
  Result := '';                                     
  n := q.AggGroups('AggNDS');
  h := Length(n) - 1;                       
  for i := 0 to h do
  begin
    k := n[i];
    if k > 0 then
    begin
      v := q.Agg('AggNDS', k);                                  
      Result := Result + ' ' + FormatFloat('0', k) + '% - ' + c2s(v, c, '[rv] [rs] [kv] [ks]');
      if i <> h then
        Result := Result + ', ';                                                                                     
    end;
  end;            
end;

function WordsSum(aSum: Double; aSumF: Double): string;
var
  c: string;                              
begin
  if <qryDoc."fByCurr"> = '1' then
    c := <qryDoc."fCurr">
  else                  
    c := '';                                 
  Result := c2s(aSum, c);
  if aSumF > 0.0 then
    Result := Result + ',  . . ' + NDSByWords(qryGoods, c)
  else                          
    Result := Result + '.  .';                                                                
end;

function NumToWord(n: Integer): string;
var
  gNumP: array [1..20] of String;
begin
  gNumP[01] := '';
  gNumP[02] := '';
  gNumP[03] := '';
  gNumP[04] := '';
  gNumP[05] := '';
  gNumP[06] := '';
  gNumP[07] := '';
  gNumP[08] := '';
  gNumP[09] := '';
  gNumP[10] := '';
  gNumP[11] := '';
  gNumP[12] := '';
  gNumP[13] := '';
  gNumP[14] := '';
  gNumP[15] := '';
  gNumP[16] := '';
  gNumP[17] := '';
  gNumP[18] := '';
  gNumP[19] := '';
  gNumP[20] := '';
  if (n < 21) and (n > 0) then
  begin
    Result := gNumP[n];
  end;
end;

function GetRecordCount(aQuery: TfrxUIBQuery): Integer;
begin
  Result := 0;
  aQuery.Open;
  while not aQuery.EOF do
  begin
    Result := Result + 1;
    aQuery.Next;                                  
  end;
  aQuery.Close;                    
end;

begin

end.