(module df-lists
  mzscheme
  
  (provide get
           base-fields)
  
  (define (get dfields field)
    (let ([table (car dfields)]
          [rest (cdr dfields)])
      
      (define (g-f rest)
        (if (null? rest)
            #f
            (if (and (list? (car rest)) (eq? (caar rest) field))
                (car rest)
                (if (eq? (car rest) field)
                    (car rest)
                    (g-f (cdr rest))))))
                       
    (g-f rest)))
  
  (define (base-fields dfields)
    (let ([table (car dfields)]
          [fields (cdr dfields)])
      (map (lambda (field) (if (list? field) (car field) field)) fields)))

  )