(module export-utils
  mzscheme
  
  (require "utils.scm"
           (prefix al. "alists.scm")
           (prefix qu. "query-utils.scm"))
  
  (provide nnvl
           field-value
           field-write-bytes)
  
  (define (nnvl name expr)
    (qu.nnvl (cadr (assq name (eval 'export.params))) expr))
  
  (define (field-value get-field-index-proc row)
    (lambda (field)
      (vector-ref row (get-field-index-proc field))))
  
  (define (field-write-bytes get-field-index-proc row)
    (lambda (field . count)
      (let ([data (vector-ref row (get-field-index-proc field))])
        (if (null? count)
            (write-bytes data)
            (write-bytes data (current-output-port) 0 (min (bytes-length data) (car count)))))))
  
  )

#|

;|#