(module query-utils
  mzscheme
  
  (require "utils.scm")
  
  (provide nnvl
           set-part)
  
  (define r-param (regexp "\\?"))
  
  (define (null-param? param)
    (or (eq? param '|000000000000|)
        (eq? param '|1899-12-30 00:00:00.0000|)
        (eq? param '|1899-12-30|)
        (eq? param '|00:00:00.0000|)))
  
  (define (nnvl value expr)
    (if (null-param? value)
        ""
        (regexp-replace r-param expr (mix value))))
  
  (define (set-part query part value)
    (regexp-replace (mix "\\[" part "\\]") query value))
  
  )

#|

(require query-utils)

;(display (nnvl '|000000000008| "jsdfhjdf ? sdfkjsdfk"))

(display (regexp-replace "\\[abc\\]" "asas [abc] sdfsdfsd" "Preved!"))

;|#